<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/redpacket/withdrawallog";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          menu:false,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "",
              prop: "id",
              hide: true,
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "姓名",
              prop: "userName",
              search: true,
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "手机号",
              prop: "phone",
              search: true,
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "",
              prop: "createUserId",
              hide: true,
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "接收人Id",
              prop: "receiverUserId",
              hide: true,
              rules: [{
                required: true,
                message: "请输入接收人Id",
                trigger: "blur"
              }]
            },
            {
              label: "账户",
              prop: "receiverAccount",
              hide: true,
              rules: [{
                required: true,
                message: "请输入账户",
                trigger: "blur"
              }]
            },
            {
              label: "提取金额",
              prop: "amount",
              rules: [{
                required: true,
                message: "请输入金额",
                trigger: "blur"
              }]
            },
            {
              label: "接收人账户类型:0 支付宝 ",
              hide: true,
              prop: "receiverType",
              rules: [{
                required: true,
                message: "请输入接收人账户类型:0 支付宝 ",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "remarks",
              hide: true,
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
            {
              label: "是否成功 0 失败 1 成功",
              prop: "isSuccess",
              hide: true,
              rules: [{
                required: true,
                message: "请输入是否成功 0 失败 1 成功",
                trigger: "blur"
              }]
            },
            {
              label: "失败原因",
              prop: "failureReason",
              hide: true,
              rules: [{
                required: true,
                message: "请输入失败原因",
                trigger: "blur"
              }]
            },
            {
              label: "实际到账金额",
              prop: "realAmount",
              rules: [{
                required: true,
                message: "请输入实际金额",
                trigger: "blur"
              }]
            },
            {
              label: "之前的金额",
              prop: "beforeAmount",
              hide: true,
              rules: [{
                required: true,
                message: "请输入之前的金额",
                trigger: "blur"
              }]
            },
            {
              label: "之后的金额",
              prop: "afterAmount",
              hide: true,
              rules: [{
                required: true,
                message: "请输入之后的金额",
                trigger: "blur"
              }]
            },
            {
              label: "提取时间",
              prop: "createTime",
            },
            {
              label: "提取时间",
              prop: "timeRange",
              search: true,
              searchRange: true,
              hide: true,
              type: 'datetimerange',
              defaultTime:['00:00:00', '23:59:59'],
              format:'yyyy-MM-dd HH:mm:ss',
              valueFormat:'yyyy-MM-dd HH:mm:ss',
              startPlaceholder: '开始时间',
              endPlaceholder: '结束时间',
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bladepaylog_add, false),
          viewBtn: this.vaildData(this.permission.bladepaylog_view, false),
          delBtn: this.vaildData(this.permission.bladepaylog_delete, false),
          editBtn: this.vaildData(this.permission.bladepaylog_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        console.log(this.query)
        if (this.query.timeRange) {
          this.query.startTime = this.query.timeRange[0];
          this.query.endTime = this.query.timeRange[1];
        }
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
